## qtmips 0.8.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
cmake_policy(VERSION 3.10)

project(QtMips
        LANGUAGES C CXX
        VERSION 0.8.0
        DESCRIPTION "MIPS CPU simulator for education purposes")

set(KAREL_KOCI "Karel Koci <cynerd@email.cz>")
set(PAVEL_PISA "Pavel Pisa <pisa@cmp.felk.cvut.cz>")
set(JAKUB_DUPAK "Jakub Dupak <dev@jakubdupak.com>")

set(PROJECT_HOMEPAGE_URL "https://github.com/cvut/qtmips")
set(GENERIC_NAME "MIPS CPU simulator")
set(LICENCE "GPL-3.0-or-later")
set(LONG_DESCRIPTION
    "RISC-V CPU simulator for education purposes with pipeline and cache visualization.")
string(TIMESTAMP YEAR "%Y")

include(cmake/CopyrightTools.cmake)


copyright(
    "Copyright (c) 2017-2019 ${KAREL_KOCI}"
    "Copyright (c) 2019-${YEAR} ${PAVEL_PISA}"
	"Copyright (c) 2020-${YEAR} ${JAKUB_DUPAK}"
    "Copyright (c) 2020-${YEAR} ${MAX_HOLLMANN}")

include(cmake/GPL-3.0-or-later.cmake)

# =============================================================================
# Configurable options
# =============================================================================

set(DEV_MODE false CACHE BOOL "Enable developer options in this CMake, like packaging.\
    They should be ignored, when user just wants to build this project.")
set(FORCE_ELFLIB_STATIC false CACHE BOOL
    "Use included statically linked libelf even if system one is available.")
set(SANITIZERS "address,undefined" CACHE STRING
    "Runtime sanitizers to use in debug builds.
    Column separated subset of {address, memory, undefined, thread} or none.
    Memory and address cannot be used at the same time.")
set(EXECUTABLE_OUTPUT_PATH "${CMAKE_BINARY_DIR}/target"
    CACHE STRING "Absolute path to place executables to.")
set(PACKAGE_OUTPUT_PATH "${EXECUTABLE_OUTPUT_PATH}/pkg"
    CACHE STRING "Absolute path to place generated package files.")


# =============================================================================
# Generated variables
# =============================================================================

if(${CMAKE_SYSTEM_NAME} MATCHES "Emscripten")
	set(WASM true)
else()
	set(WASM false)
endif()
set(CXX_TEST_PATH ${EXECUTABLE_OUTPUT_PATH})
set(C_TEST_PATH ${EXECUTABLE_OUTPUT_PATH})

# I don't want to relly on the assumption, that this file is invoked as root
# project. Therefore I propagate the information to all subprojects
# MAIN_PROJECT_*. Lowercase and uppercase are used for executable names and
# C defines, respectively.
set(MAIN_PROJECT_NAME "${PROJECT_NAME}")
set(MAIN_PROJECT_VERSION "${PROJECT_VERSION}")
set(MAIN_PROJECT_ORGANIZATION "FEE CTU")
set(MAIN_PROJECT_HOMEPAGE_URL "${PROJECT_HOMEPAGE_URL}")
string(TOLOWER "${PROJECT_NAME}" MAIN_PROJECT_NAME_LOWER)
string(TOUPPER "${PROJECT_NAME}" MAIN_PROJECT_NAME_UPPER)

# =============================================================================
# CMake config and tools
# =============================================================================

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

if(CMAKE_VERSION VERSION_LESS "3.7.0")
	set(CMAKE_INCLUDE_CURRENT_DIR ON)
endif()

include(cmake/BuildType.cmake)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# =============================================================================
# Build options
# - common to all subdirs
# =============================================================================

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if(NOT "${SANITIZERS}" MATCHES "none" AND NOT "${WASM}")
	set(CMAKE_C_FLAGS_DEBUG
	    "${CMAKE_C_FLAGS_DEBUG} -fno-omit-frame-pointer -fsanitize=${SANITIZERS} -g -g3 -ggdb")
	set(CMAKE_CXX_FLAGS_DEBUG
	    "${CMAKE_CXX_FLAGS_DEBUG} -fno-omit-frame-pointer -fsanitize=${SANITIZERS} -g -g3 -ggdb")
	set(CMAKE_LINKER_FLAGS_DEBUG
	    "${CMAKE_LINKER_FLAGS_DEBUG} -fno-omit-frame-pointer -fsanitize=${SANITIZERS}")
endif()


if("${BUILD_RELEASE}")
	message(STATUS "Debug prints globally suppressed.")
	add_compile_definitions(QT_NO_DEBUG_OUTPUT=1)
endif()

include_directories("src" "src/machine")

## ============================================================================
## Warning level
## ============================================================================

if(MSVC)
	add_compile_options(/W4 /WX)
else()
	add_compile_options(-Wall -Wextra)
	if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
		# This is currently a wontfix and it will be OK in cpp20.
		add_compile_options(-Wno-c99-designator)
	endif()
endif()

# =============================================================================
# Dependencies
# =============================================================================

if("${WASM}")
	message(STATUS "WASM build detected")

	message(STATUS "Enabled WASM exception handling")
	add_link_options("SHELL:-s DISABLE_EXCEPTION_CATCHING=0")
	# Extra options for WASM linking
	add_link_options("SHELL:-s FETCH=1")
	add_link_options("SHELL:-s WASM=1")
	add_link_options("SHELL:-s FULL_ES2=1")
	add_link_options("SHELL:-s FULL_ES3=1")
	add_link_options("SHELL:-s USE_WEBGL2=1")
	add_link_options("SHELL:-s ALLOW_MEMORY_GROWTH=1")
	add_link_options("SHELL:-s EXTRA_EXPORTED_RUNTIME_METHODS=[\"UTF16ToString\",\"stringToUTF16\"]")
	add_link_options("--bind")

	add_compile_definitions(QT_NO_DEBUG_OUTPUT=1)
	message(STATUS "Debug output disabled")

else()
	# Not available for WASM
	enable_testing()

	if(NOT "${FORCE_ELFLIB_STATIC}")
		find_package(LibElf)
		if("${LibElf_FOUND}")
			# Turn non-cmake library into a cmake target
			add_library(libelf INTERFACE)
			target_link_libraries(libelf INTERFACE ${LIBELF_LIBRARY})
			target_include_directories(libelf INTERFACE ${LIBELF_INCLUDE})
			message(STATUS "Using system libelf")
		endif()
	endif()
endif()

if("${WASM}" OR "${FORCE_ELFLIB_STATIC}" OR NOT "${LibElf_FOUND}")
	message(STATUS "Using local libelf fallback.")
	add_subdirectory("external/libelf")
endif()

find_package(Qt5
             REQUIRED COMPONENTS Core Widgets Gui Test
             OPTIONAL_COMPONENTS PrintSupport)

message(STATUS "Qt5 version: ${Qt5Core_VERSION}")
message(STATUS "Qt5 print support: ${Qt5PrintSupport_FOUND}")

# =============================================================================
# Sources
# =============================================================================

add_subdirectory("src/common")
add_subdirectory("src/machine")
add_subdirectory("src/assembler")
add_subdirectory("src/os_emulation")
add_subdirectory("src/gui")
if(NOT "${WASM}")
	add_subdirectory("src/cli")
endif()

# =============================================================================
# Installation
# =============================================================================

# Prior to CMake version 3.13, installation must be performed in the subdirectory,
# there the target was created. Therefore executable installation is to be found
# in corresponding CMakeLists.txt.

configure_file(data/gui.desktop.in
               "${EXECUTABLE_OUTPUT_PATH}/${MAIN_PROJECT_NAME_LOWER}.desktop")

install(FILES "data/icons/gui.svg"
        DESTINATION "share/icons/hicolor/scalable/apps"
        RENAME "${MAIN_PROJECT_NAME_LOWER}_gui.svg")
install(FILES "data/icons/48x48/gui.png"
        DESTINATION "share/icons/hicolor/48x48/apps"
        RENAME "${MAIN_PROJECT_NAME_LOWER}_gui.png")
install(FILES "${EXECUTABLE_OUTPUT_PATH}/${MAIN_PROJECT_NAME_LOWER}.desktop"
        DESTINATION share/applications)

# =============================================================================
# Packages
# =============================================================================

if("${DEV_MODE}")
	# The condition prevents execution of this section during regular user installation.
	# It created files useless to normal users and requires additional tools (git, xz).
	message(STATUS "Packaging tools enabled.")

	set(PACKAGE_NAME "${MAIN_PROJECT_NAME_LOWER}")
	set(PACKAGE_VERSION "${PROJECT_VERSION}")
	set(PACKAGE_RELEASE "1")
	set(PACKAGE_SOURCE_ARCHIVE_FILE "${PACKAGE_NAME}_${PACKAGE_VERSION}.orig.tar.xz")
	set(PACKAGE_SOURCE_ARCHIVE_PATH "${PACKAGE_OUTPUT_PATH}/${PACKAGE_SOURCE_ARCHIVE_FILE}")
	set(PACKAGE_TOPLEVEL_DIR "${PACKAGE_NAME}-${PACKAGE_VERSION}")
	set(PACKAGE_DESCRIPTION "${PROJECT_DESCRIPTION}")
	set(PACKAGE_LONG_DESCRIPTION "${LONG_DESCRIPTION}")
	set(PACKAGE_MAINTAINER "${JAKUB_DUPAK}")
	set(PACKAGE_URL "${PROJECT_HOMEPAGE_URL}")
	set(PACKAGE_GIT "github.com:cvut/qtmips.git")
	set(PACKAGE_LICENCE "${LICENCE} ")

	include(cmake/PackageTools.cmake)

	# Inject up-to-date information into package config files.
	package_config_file(appimage appimage.yml extras/packaging/appimage/appimage.yml.in)
	package_config_file(archlinux PKGBUILD extras/packaging/arch/PKGBUILD.in)
	package_config_file(rpm ${PACKAGE_NAME}.spec extras/packaging/rpm/spec.in)
	# Debian uses whole directory which has to be saved to archive and shipped.
	package_debian_quilt(deb
	                     ${PACKAGE_NAME}_${PACKAGE_VERSION}-${PACKAGE_RELEASE}.dsc
	                     extras/packaging/deb/dsc.in
	                     extras/packaging/deb/debian
	                     ${PACKAGE_NAME}_${PACKAGE_VERSION}-${PACKAGE_RELEASE}.debian.tar.xz)
	# Creates bunch of files in ${CMAKE_BINARY_DIR}/target/pkg that you can just pass to
	# Open Build Service and it will build all packaging.
	# TODO: Currently changelog is not handled automatically.
	add_custom_target(open_build_service_bundle
	                  DEPENDS ${PACKAGE_SOURCE_ARCHIVE_FILE} appimage archlinux deb rpm
	                  WORKING_DIRECTORY ${EXECUTABLE_OUTPUT_PATH}/pkg)
endif()

configure_file(src/project_info.h.in ${CMAKE_CURRENT_LIST_DIR}/src/project_info.h @ONLY)

=== src/assembler/CMakeLists.txt ===
project(assembler
        DESCRIPTION "Simple assembler library to use in the UI.")

set(CMAKE_AUTOMOC ON)

set(assembler_SOURCES
        fixmatheval.cpp
        simpleasm.cpp
        )
set(assembler_HEADERS
        fixmatheval.h
        messagetype.h
        simpleasm.h
        )

add_library(assembler STATIC
        ${assembler_SOURCES}
        ${assembler_HEADERS})
target_link_libraries(assembler
        PRIVATE Qt5::Core)

=== src/cli/CMakeLists.txt ===
project(cli
        LANGUAGES C CXX
        VERSION ${MAIN_PROJECT_VERSION}
        DESCRIPTION "Simulator command-line UI.")

set(CMAKE_AUTOMOC ON)

set(cli_SOURCES
    chariohandler.cpp
    main.cpp
    msgreport.cpp
    reporter.cpp
    tracer.cpp
    )
set(cli_HEADERS
    chariohandler.h
    msgreport.h
    reporter.h
    tracer.h
    )

add_executable(cli
               ${cli_SOURCES}
               ${cli_HEADERS})
target_link_libraries(cli
                      PRIVATE Qt5::Core machine assembler)
target_compile_definitions(cli
                           PRIVATE
                           APP_ORGANIZATION=\"${MAIN_PROJECT_ORGANIZATION}\"
                           APP_ORGANIZATION_DOMAIN=\"${MAIN_PROJECT_HOMEPAGE_URL}\"
                           APP_NAME=\"${MAIN_PROJECT_NAME}\"
                           APP_VERSION=\"${PROJECT_VERSION}\"
                           ENV_CONFIG_FILE_NAME=\"${MAIN_PROJECT_NAME_UPPER}_CONFIG_FILE\")
set_target_properties(cli PROPERTIES
                      OUTPUT_NAME "${MAIN_PROJECT_NAME_LOWER}_${PROJECT_NAME}")

# =============================================================================
# Installation
# =============================================================================

# Prior to CMake version 3.13, installation must be performed in the subdirectory,
# there the target was created. Therefore executable installation is to be found
# in corresponding CMakeLists.txt.

install(TARGETS cli
        RUNTIME DESTINATION bin)

=== src/common/CMakeLists.txt ===
project(common
        DESCRIPTION "Utils shared between multiple subprojects.")

add_subdirectory(polyfills)

set(common_HEADERS
        endian.h
        logging.h
        logging_format_colors.h
        )

# =============================================================================
# Target for usage of this header library
# - this is header only library and it is implicitly available in the whole
#   project
# =============================================================================

# =============================================================================
# Tests
# - It is highly recommended to run these tests anytime you use a different
#   compiler or platform as this code is platform/compiler specific.
# =============================================================================

enable_testing()
set(CMAKE_AUTOMOC ON)

# Put tests here...

=== src/gui/CMakeLists.txt ===
project(gui
        LANGUAGES C CXX
        VERSION ${MAIN_PROJECT_VERSION}
        DESCRIPTION "Graphical UI for the simulator")

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

set(gui_SOURCES
        aboutdialog.cpp
        cachedock.cpp
        cacheview.cpp
        cop0dock.cpp
        coreview/adder.cpp
        coreview/alu.cpp
        coreview/and.cpp
        coreview/connection.cpp
        coreview/constant.cpp
        coreview/instructionview.cpp
        coreview/junction.cpp
        coreview/latch.cpp
        coreview/logicblock.cpp
        coreview/memory.cpp
        coreview/minimux.cpp
        coreview/multiplexer.cpp
        coreview/multitext.cpp
        coreview/programcounter.cpp
        coreview/registers.cpp
        coreview/value.cpp
        coreview.cpp
        extprocess.cpp
        fontsize.cpp
        gotosymboldialog.cpp
        graphicsview.cpp
        memorydock.cpp
        memorymodel.cpp
        memorytableview.cpp
        messagesdock.cpp
        messagesmodel.cpp
        messagesview.cpp
        newdialog.cpp
        hexlineedit.cpp
        highlighterasm.cpp
        highlighterc.cpp
        hinttabledelegate.cpp
        lcddisplaydock.cpp
        lcddisplayview.cpp
        main.cpp
        mainwindow.cpp
        peripheralsdock.cpp
        peripheralsview.cpp
        programdock.cpp
        programmodel.cpp
        programtableview.cpp
        registersdock.cpp
        savechangeddialog.cpp
        srceditor.cpp
        statictable.cpp
        terminaldock.cpp
        textsignalaction.cpp
        )
set(gui_HEADERS
        aboutdialog.h
        cachedock.h
        cacheview.h
        cop0dock.h
        coreview/adder.h
        coreview/alu.h
        coreview/and.h
        coreview/connection.h
        coreview/constant.h
        coreview/coreview_colors.h
        coreview/instructionview.h
        coreview/junction.h
        coreview/latch.h
        coreview/logicblock.h
        coreview/memory.h
        coreview/minimux.h
        coreview/multiplexer.h
        coreview/multitext.h
        coreview/programcounter.h
        coreview/registers.h
        coreview/value.h
        coreview.h
        extprocess.h
        fontsize.h
        gotosymboldialog.h
        graphicsview.h
        memorydock.h
        memorymodel.h
        memorytableview.h
        messagesdock.h
        messagesmodel.h
        messagesview.h
        newdialog.h
        hexlineedit.h
        highlighterasm.h
        highlighterc.h
        hinttabledelegate.h
        lcddisplaydock.h
        lcddisplayview.h
        mainwindow.h
        peripheralsdock.h
        peripheralsview.h
        programdock.h
        programmodel.h
        programtableview.h
        registersdock.h
        savechangeddialog.h
        srceditor.h
        statictable.h
        terminaldock.h
        textsignalaction.h
        )
set(gui_UI
    gotosymboldialog.ui
    NewDialog.ui
    peripheralsview.ui
    MainWindow.ui
    NewDialogCache.ui
    )
set(gui_RESOURCES
        icons.qrc
        samples.qrc
        )


if("${WASM}")
	message(STATUS "gui :: Including WASM only files.")
	list(APPEND gui_SOURCES qhtml5file_html5.cpp)
	list(APPEND gui_HEADERS qhtml5file.h)
endif()

# MACOS
set(ICON_NAME gui)
set(ICON_PATH ${CMAKE_SOURCE_DIR}/data/icons/macos/${ICON_NAME}.icns)
# END MACOS

add_executable(gui
               ${ICON_PATH}
               ${gui_SOURCES}
               ${gui_HEADERS}
               ${gui_UI}
               ${gui_RESOURCES})
target_include_directories(gui PUBLIC . coreview)
target_link_libraries(gui
        PRIVATE Qt5::Core Qt5::Widgets Qt5::Gui
        PRIVATE machine os_emulation assembler)
target_compile_definitions(gui
                           PRIVATE
                           APP_ORGANIZATION=\"${MAIN_PROJECT_ORGANIZATION}\"
                           APP_ORGANIZATION_DOMAIN=\"${MAIN_PROJECT_HOMEPAGE_URL}\"
                           APP_GIT=\"${MAIN_PROJECT_HOMEPAGE_URL}\"
                           APP_NAME=\"${MAIN_PROJECT_NAME}\"
                           APP_VERSION=\"${MAIN_PROJECT_VERSION}\"
                           ENV_CONFIG_FILE_NAME=\"${MAIN_PROJECT_NAME_UPPER}_CONFIG_FILE\")
set_target_properties(gui PROPERTIES
                      OUTPUT_NAME "${MAIN_PROJECT_NAME_LOWER}_${PROJECT_NAME}")

if(${Qt5PrintSupport_FOUND})
    target_link_libraries(gui PRIVATE Qt5::PrintSupport)
    target_compile_definitions(gui PRIVATE WITH_PRINTING=1)
endif()

# MACOS
set_property(SOURCE ${ICON_PATH}
             PROPERTY MACOSX_PACKAGE_LOCATION Resources)
set_target_properties(gui PROPERTIES
                      MACOSX_BUNDLE true
                      MACOSX_BUNDLE_GUI_IDENTIFIER cz.cvut.fel.${MAIN_PROJECT_ORGANIZATION}.gui
                      MACOSX_BUNDLE_BUNDLE_NAME ${MAIN_PROJECT_NAME}
                      MACOSX_BUNDLE_BUNDLE_VERSION "${MAIN_PROJECT_VERSION}"
                      MACOSX_BUNDLE_SHORT_VERSION_STRING "${MAIN_PROJECT_VERSION}"
                      MACOSX_BUNDLE_ICONFILE ${ICON_NAME}
                      )
# END MACOS

# =============================================================================
# Installation
# =============================================================================

# Prior to CMake version 3.13, installation must be performed in the subdirectory,
# there the target was created. Therefore executable installation is to be found
# in corresponding CMakeLists.txt.

install(TARGETS gui
        RUNTIME DESTINATION bin
        BUNDLE DESTINATION ${EXECUTABLE_OUTPUT_PATH}
        )

=== src/machine/CMakeLists.txt ===
project(machine
        DESCRIPTION "The actual simulator as a library. Link with an UI of your choice.")

set(CMAKE_AUTOMOC ON)

set(machine_SOURCES
        alu.cpp
        cop0state.cpp
        core.cpp
        instruction.cpp
        machine.cpp
        machineconfig.cpp
        memory/backend/lcddisplay.cpp
        memory/backend/memory.cpp
        memory/backend/peripheral.cpp
        memory/backend/peripspiled.cpp
        memory/backend/serialport.cpp
        memory/cache/cache.cpp
        memory/cache/cache_policy.cpp
        memory/frontend_memory.cpp
        memory/memory_bus.cpp
        programloader.cpp
        registers.cpp
        simulator_exception.cpp
        symboltable.cpp
        )

set(machine_HEADERS
        alu.h
        cop0state.h
        core.h
        instruction.h
        machine.h
        machineconfig.h
        machinedefs.h
        memory/address.h
        memory/backend/backend_memory.h
        memory/backend/lcddisplay.h
        memory/backend/memory.h
        memory/backend/peripheral.h
        memory/backend/peripspiled.h
        memory/backend/serialport.h
        memory/cache/cache.h
        memory/cache/cache_policy.h
        memory/cache/cache_types.h
        memory/frontend_memory.h
        memory/memory_bus.h
        memory/memory_utils.h
        programloader.h
        registers.h
        register_value.h
        simulator_exception.h
        symboltable.h
        utils.h
        machine_global.h
        )
set(machine_TESTS
        tests/data/cache_test_performance_data.h
        tests/tst_machine.h
        tests/utils/integer_decomposition.h
        tests/testalu.cpp
        tests/testcache.cpp
        tests/testcore.cpp
        tests/testinstruction.cpp
        tests/testmemory.cpp
        tests/testprogramloader.cpp
        tests/testregisters.cpp
        tests/tst_machine.cpp
        )


# Object library is preferred, because the library archive is never really
# needed. This option skips the archive creation and links directly .o files.
add_library(machine STATIC
        ${machine_SOURCES}
        ${machine_HEADERS})
target_link_libraries(machine
        PRIVATE Qt5::Core
        PUBLIC libelf)

if (NOT ${WASM})
    # Machine tests (not available on WASM)
    add_executable(machine_unit_tests ${machine_TESTS})
    target_link_libraries(machine_unit_tests
            PRIVATE machine Qt5::Core Qt5::Test)

    add_test(NAME machine_unit_tests
            COMMAND machine_unit_tests)
endif ()

=== src/os_emulation/CMakeLists.txt ===
project(os_emulation
        DESCRIPTION "Simple emulation of a Linux like kernel")

set(CMAKE_AUTOMOC ON)

set(os_emulation_SOURCES
        ossyscall.cpp
        )
set(os_emulation_HEADERS
        ossyscall.h
        syscall_nr.h
        target_errno.h
        )

add_library(os_emulation STATIC
        ${os_emulation_SOURCES}
        ${os_emulation_HEADERS})
target_link_libraries(os_emulation
        PRIVATE Qt5::Core)

=== src/common/polyfills/CMakeLists.txt ===
project(polyfills
        DESCRIPTION "Helper code to unify access to compiler intrinsics and
                     provide fallback implementations.")

set(polyfills_HEADERS
        endian_detection.h
        byteswap.h
        )

# =============================================================================
# Target for usage of this header library
# - this is header only library and it is implicitly available in the whole
#   project
# =============================================================================

# =============================================================================
# Tests
# - It is highly recommended to run these tests anytime you use a different
#   compiler or platform as this code is platform/compiler specific.
# =============================================================================

enable_testing()
set(CMAKE_AUTOMOC ON)

# Put tests here...

=== debian/changelog ===
qtmips (0.8.0-1) unstable; urgency=medium
   
  * Debian package updated to version 0.8.0-1.
  * CMake build backported from qtrvsim
  * New memory model

 -- Jakub Dupak <dev@jakubdupak.com>  Fri, 19 Nov 2021 14:56:38 +0100

qtmips (0.7.5) unstable; urgency=medium

  * Debian package updated to version 0.7.5.
  * Improve UI compatbility with dark color schemes (by Michal Maly, MadCatX)
  * prepare-release: document alternative Debian package preparation in quilt mode.
  * Enable dock widows nesting to enable show cache + memory simultaneously (by Frantisek Vacek)
  * AppImage build run (by Frantisek Vacek)
  * qtmips_cli: add option to connect serial port input and output to file.
  * samples: template-os.S template.S fixed SPILED_REG_BASE definition.
  * README: add documentation how to modify comprocessor 0 regs (by Jan Kaisrlik)
  * EADME.md: fix reference to uart rx interrupt mask (by Jan Kaisrlik)
  * Fix open of ELF files using national alphabets in the path names on Windows.
  * qtmips_gui: fix response to user decision to save modified file when make is invoked.

 -- Pavel Pisa <pisa@cmp.felk.cvut.cz>  Sun, 06 Sep 2020 13:16:34 +0200

qtmips (0.7.4) unstable; urgency=medium

  * Debian package updated to version 0.7.4.
  * debian packaging: add git attribute to merge changelog.
  * debian packaging: add watch file for GitHub QtMips repository.

 -- Pavel Pisa <pisa@cmp.felk.cvut.cz>  Sun, 15 Sep 2019 20:32:41 +0200

qtmips (0.7.3) unstable; urgency=medium

  * Debian package updated to version 0.7.3.
  * Implemented SKIP/SPACE assembler directives.
  * Add OpenHub statistic page link.
  * Provide support for include directive in simple assembler.
  * In include, use content from editor if file is already open.
  * Add #pragma processing to integrated assembler and its usage to control windows.
  * Use #pragma in examples to lower initial learning curve.
  * samples: simple-lw-sw-ia.S: place data section to 0x2000 address.
 
 -- Pavel Pisa <pisa@cmp.felk.cvut.cz>  Thu, 12 Sep 2019 11:47:46 +0200

qtmips (0.7.2) unstable; urgency=medium

  * Debian package updated to version 0.7.2.
  * More changes to use dialog open instead of exec (Emscripten does not support exec).
  * Updates to RPM packaging and spec file to better follow Suse rules.
  * Move fixmatheval and assembly compiler to separate library independent on Qt GUI API.
  * Implemented message window to report compilation errors.
  * Store operator text description in the fixmatheval operators tree.
  * Simple assembler moved to separate class which is independent on Qt GUI API.
  * Do not open editor twice for same filename.
  * Enable CLI version to use simple assembler.
  * Update editor search algorithm to prefer current editor for unnamed buffers.
  * Add config option to reset machine before internal assembler starts.
  * Include C language syntax highlighter for alternative sources editing.
  * Action to execute external make command and ask for unsaved sources.
  * Ask to save modified files on exit.
  * Ask for modified source close and handle unnamed sources close.
  * Replace shortcuts to not hide Ctrl+C and some others.
  * Implemented ASCII and ASCIZ operations.
  * Include actions New source and Close source on toolbar.
  * Make program and memory window visible when address requested from symbol dialog.
  * Add embedded examples menu and resources.

 -- Pavel Pisa <pisa@cmp.felk.cvut.cz>  Wed, 21 Aug 2019 00:13:06 +0200

qtmips (0.7.1) unstable; urgency=medium

  * Debian package updated to version 0.7.1.
  * Add option to parse and show symbolic registers names.
  * Implemented simple integrated assembler - it is not recommended for advanced users.
  * Updated instructions parsing to be usable for integrated assembler.
  * Change instruction parsing to allow multiple words pseudo-operations.
  * Implemented simple expressions and labels/symbols evaluation.
  * Simple highlighter for assembly language added.
  * Include simple text editor in QtMips emulator.
  * Fix memory leakages which repeat during program operation.
  * Externally caused address-space changes (i.e. from peripherals) update memory view.
  * Provide option to hide coreview to speedup simulation.

 -- Pavel Pisa <pisa@cmp.felk.cvut.cz>  Wed, 03 Jul 2019 12:18:15 +0200

qtmips (0.7.0) unstable; urgency=medium

  * Debian package updated to version 0.7.0.
  * Include simple LCD frame-buffer and display implementation.
  * Simulate push of dial buttons by check box.
  * Allow to create simulator without loaded executable.
  * Printing/export to PDF file reduces print area/page to actual image size.
  * Disable text elide for memory and program views (fix for MAC OS).
  * Implement standard zoom handling by mouse wheel and keys.

 -- Pavel Pisa <pisa@cmp.felk.cvut.cz>  Fri, 28 Jun 2019 15:38:52 +0200

qtmips (0.6.8) unstable; urgency=medium

  * Debian package updated to version 0.6.8.
  * Coreview multiplexers updated and added for branch compare forward.
  * qtmips_gui: set application window icon.
  * Set gray background to stalled instructions/idled stages.
  * Setting background color dial
  * qtmips_cli: start report in decimal mode.

 -- Pavel Pisa <pisa@cmp.felk.cvut.cz>  Mon, 01 Apr 2019 15:26:46 +0200

qtmips (0.6.7) unstable; urgency=medium

  * Debian package updated to version 0.6.7.
  * Change single cycle core with delay slot to use separate fetch stage.
  * Program listing and stages use color background.
  * Correct write through spelling. Reported by Richard Susta.
  * qtmips_cli can be used for cache statistic and result memory tests.

 -- Pavel Pisa <pisa@cmp.felk.cvut.cz>  Wed, 27 Mar 2019 00:38:24 +0100

qtmips (0.6.6) unstable; urgency=medium

  * Corrected row and column output in cache address fields.
  * Highlight cache read and write acesses.
  * Highlight registers and coprocessor 0 read and writes.

 -- Pavel Pisa <pisa@cmp.felk.cvut.cz>  Sun, 17 Mar 2019 20:51:55 +0100

qtmips (0.6.5) unstable; urgency=medium



=== debian/control ===
Source: qtmips
Section: devel
Priority: optional
Maintainer: Jakub Dupak <dev@jakubdupak.com>
Build-Depends: debhelper (>= 9), qtbase5-dev, libelf-dev, cmake
Standards-Version: 3.9.8
Homepage: https://github.com/cvut/qtmips
Vcs-Git: github.com:cvut/qtmips.git
Vcs-Browser: https://github.com/cvut/qtmips

Package: qtmips
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: MIPS CPU simulator for education purposes
 RISC-V CPU simulator for education purposes with pipeline and cache visualization.

## qtmips 0.8.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 project(QtMips
         LANGUAGES C CXX
-        VERSION 0.8.0
+        VERSION 0.8.1
         DESCRIPTION "MIPS CPU simulator for education purposes")
 
 set(KAREL_KOCI "Karel Koci <cynerd@email.cz>")
@@ -14,7 +14,7 @@
 set(GENERIC_NAME "MIPS CPU simulator")
 set(LICENCE "GPL-3.0-or-later")
 set(LONG_DESCRIPTION
-    "RISC-V CPU simulator for education purposes with pipeline and cache visualization.")
+    "MIPS CPU simulator for education purposes with pipeline and cache visualization.")
 string(TIMESTAMP YEAR "%Y")
 
 include(cmake/CopyrightTools.cmake)
@@ -23,8 +23,7 @@
 copyright(
     "Copyright (c) 2017-2019 ${KAREL_KOCI}"
     "Copyright (c) 2019-${YEAR} ${PAVEL_PISA}"
-	"Copyright (c) 2020-${YEAR} ${JAKUB_DUPAK}"
-    "Copyright (c) 2020-${YEAR} ${MAX_HOLLMANN}")
+	"Copyright (c) 2020-${YEAR} ${JAKUB_DUPAK}")
 
 include(cmake/GPL-3.0-or-later.cmake)
 
@@ -44,7 +43,7 @@
     CACHE STRING "Absolute path to place executables to.")
 set(PACKAGE_OUTPUT_PATH "${EXECUTABLE_OUTPUT_PATH}/pkg"
     CACHE STRING "Absolute path to place generated package files.")
-
+set(FORCE_COLORED_OUTPUT false CACHE BOOL "Always produce ANSI-colored output (GNU/Clang only).")
 
 # =============================================================================
 # Generated variables
@@ -90,22 +89,31 @@
 set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
-if(NOT "${SANITIZERS}" MATCHES "none" AND NOT "${WASM}")
+if(NOT "${SANITIZERS}" MATCHES "none" AND NOT "${WASM}" AND NOT "${MINGW}")
 	set(CMAKE_C_FLAGS_DEBUG
-	    "${CMAKE_C_FLAGS_DEBUG} -fno-omit-frame-pointer -fsanitize=${SANITIZERS} -g -g3 -ggdb")
+			"${CMAKE_C_FLAGS_DEBUG} -fno-omit-frame-pointer -fsanitize=${SANITIZERS} -g -g3 -ggdb")
 	set(CMAKE_CXX_FLAGS_DEBUG
-	    "${CMAKE_CXX_FLAGS_DEBUG} -fno-omit-frame-pointer -fsanitize=${SANITIZERS} -g -g3 -ggdb")
+			"${CMAKE_CXX_FLAGS_DEBUG} -fno-omit-frame-pointer -fsanitize=${SANITIZERS} -g -g3 -ggdb")
 	set(CMAKE_LINKER_FLAGS_DEBUG
-	    "${CMAKE_LINKER_FLAGS_DEBUG} -fno-omit-frame-pointer -fsanitize=${SANITIZERS}")
+			"${CMAKE_LINKER_FLAGS_DEBUG} -fno-omit-frame-pointer -fsanitize=${SANITIZERS}")
 endif()
 
 
 if("${BUILD_RELEASE}")
 	message(STATUS "Debug prints globally suppressed.")
-	add_compile_definitions(QT_NO_DEBUG_OUTPUT=1)
+	add_definitions(-DQT_NO_DEBUG_OUTPUT=1)
 endif()
 
 include_directories("src" "src/machine")
+
+
+if(${FORCE_COLORED_OUTPUT})
+	if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
+		add_compile_options(-fdiagnostics-color=always)
+	elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
+		add_compile_options(-fcolor-diagnostics)
+	endif()
+endif()
 
 ## ============================================================================
 ## Warning level
@@ -116,7 +124,7 @@
 else()
 	add_compile_options(-Wall -Wextra)
 	if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
-		# This is currently a wontfix and it will be OK in cpp20.
+		# This is currently a wont-fix and it will be OK in cpp20.
 		add_compile_options(-Wno-c99-designator)
 	endif()
 endif()
@@ -129,6 +137,8 @@
 	message(STATUS "WASM build detected")
 
 	message(STATUS "Enabled WASM exception handling")
+	add_compile_options("-fexceptions")
+	add_link_options("-fexceptions")
 	add_link_options("SHELL:-s DISABLE_EXCEPTION_CATCHING=0")
 	# Extra options for WASM linking
 	add_link_options("SHELL:-s FETCH=1")
@@ -140,7 +150,7 @@
 	add_link_options("SHELL:-s EXTRA_EXPORTED_RUNTIME_METHODS=[\"UTF16ToString\",\"stringToUTF16\"]")
 	add_link_options("--bind")
 
-	add_compile_definitions(QT_NO_DEBUG_OUTPUT=1)
+	add_definitions(-DQT_NO_DEBUG_OUTPUT=1)
 	message(STATUS "Debug output disabled")
 
 else()
@@ -164,12 +174,25 @@
 	add_subdirectory("external/libelf")
 endif()
 
-find_package(Qt5
+# Detect Qt used qt version
+# Based on article https://www.steinzone.de/wordpress/how-to-support-both-qt5-and-qt6-using-cmake/
+# Cannot use version-less approach due to Qt 5.9.5 support constraint.
+find_package(OpenGL)
+
+find_package(QT NAMES Qt6 Qt5 COMPONENTS Core REQUIRED)
+# Normally, we would use variable Qt5 or Qt6 to reference the Qt library. Here we do that through
+# this variable based on detected version major of Qt.
+set(QtLib "Qt${QT_VERSION_MAJOR}")
+find_package(${QtLib}
              REQUIRED COMPONENTS Core Widgets Gui Test
              OPTIONAL_COMPONENTS PrintSupport)
 
-message(STATUS "Qt5 version: ${Qt5Core_VERSION}")
-message(STATUS "Qt5 print support: ${Qt5PrintSupport_FOUND}")
+message(STATUS "${QtLib} version: ${${QtLib}Core_VERSION}")
+message(STATUS "${QtLib} print support: ${${QtLib}PrintSupport_FOUND}")
+
+
+# Qt 5.9.5 is the oldest supported
+add_definitions(-DQT_DISABLE_DEPRECATED_BEFORE=0x050905)
 
 # =============================================================================
 # Sources
@@ -182,6 +205,8 @@
 add_subdirectory("src/gui")
 if(NOT "${WASM}")
 	add_subdirectory("src/cli")
+	add_custom_target(all_unit_tests
+			DEPENDS common_unit_tests machine_unit_tests)
 endif()
 
 # =============================================================================

=== src/assembler/CMakeLists.txt ===
--- 
+++ 
@@ -17,4 +17,4 @@
         ${assembler_SOURCES}
         ${assembler_HEADERS})
 target_link_libraries(assembler
-        PRIVATE Qt5::Core)
+        PRIVATE ${QtLib}::Core)

=== src/cli/CMakeLists.txt ===
--- 
+++ 
@@ -23,7 +23,7 @@
                ${cli_SOURCES}
                ${cli_HEADERS})
 target_link_libraries(cli
-                      PRIVATE Qt5::Core machine assembler)
+                      PRIVATE ${QtLib}::Core machine assembler)
 target_compile_definitions(cli
                            PRIVATE
                            APP_ORGANIZATION=\"${MAIN_PROJECT_ORGANIZATION}\"

=== src/gui/CMakeLists.txt ===
--- 
+++ 
@@ -145,7 +145,7 @@
                ${gui_RESOURCES})
 target_include_directories(gui PUBLIC . coreview)
 target_link_libraries(gui
-        PRIVATE Qt5::Core Qt5::Widgets Qt5::Gui
+        PRIVATE ${QtLib}::Core ${QtLib}::Widgets ${QtLib}::Gui
         PRIVATE machine os_emulation assembler)
 target_compile_definitions(gui
                            PRIVATE
@@ -158,8 +158,8 @@
 set_target_properties(gui PROPERTIES
                       OUTPUT_NAME "${MAIN_PROJECT_NAME_LOWER}_${PROJECT_NAME}")
 
-if(${Qt5PrintSupport_FOUND})
-    target_link_libraries(gui PRIVATE Qt5::PrintSupport)
+if(${${QtLib}PrintSupport_FOUND})
+    target_link_libraries(gui PRIVATE ${QtLib}::PrintSupport)
     target_compile_definitions(gui PRIVATE WITH_PRINTING=1)
 endif()

=== src/machine/CMakeLists.txt ===
--- 
+++ 
@@ -75,14 +75,14 @@
         ${machine_SOURCES}
         ${machine_HEADERS})
 target_link_libraries(machine
-        PRIVATE Qt5::Core
+        PRIVATE ${QtLib}::Core
         PUBLIC libelf)
 
 if (NOT ${WASM})
     # Machine tests (not available on WASM)
     add_executable(machine_unit_tests ${machine_TESTS})
     target_link_libraries(machine_unit_tests
-            PRIVATE machine Qt5::Core Qt5::Test)
+            PRIVATE machine ${QtLib}::Core ${QtLib}::Test)
 
     add_test(NAME machine_unit_tests
             COMMAND machine_unit_tests)

=== src/os_emulation/CMakeLists.txt ===
--- 
+++ 
@@ -16,4 +16,4 @@
         ${os_emulation_SOURCES}
         ${os_emulation_HEADERS})
 target_link_libraries(os_emulation
-        PRIVATE Qt5::Core)
+        PRIVATE ${QtLib}::Core)

=== src/common/polyfills/CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,14 @@
 project(polyfills
-        DESCRIPTION "Helper code to unify access to compiler intrinsics and
+		DESCRIPTION "Helper code to unify access to compiler intrinsics and
                      provide fallback implementations.")
 
 set(polyfills_HEADERS
-        endian_detection.h
-        byteswap.h
-        )
+		endian_detection.h
+		byteswap.h
+		qt5/qfontmetrics.h
+		qt5/qlinef.h
+		qt5/qtableview.h
+		)
 
 # =============================================================================
 # Target for usage of this header library

=== debian/control ===
--- 
+++ 
@@ -12,4 +12,4 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: MIPS CPU simulator for education purposes
- RISC-V CPU simulator for education purposes with pipeline and cache visualization.
+ MIPS CPU simulator for education purposes with pipeline and cache visualization.
